<template>
  <div>
    <div
      class="p-4 p-md-5 mb-4 text-white rounded"
      style="background-color: #3b3b3b"
    >
      <div class="container">
        <div class="col-md-8 px-0">
          <h1 class="display-4 ">Aksirelawan</h1>
          <h5 class="fst-italic">
            Aksirelawan merupakan Situs donasi dan menggalang dana (fundraising)
            untuk inisiatif, campaign dan program sosial
          </h5>
          <p class="lead my-3">
            "Bila kita menolong orang lain, suatu saat kita akan ditolong.
            Waktunya mungkin besok atau seratus tahun lagi. Itulah hukum alam
            yang sangat matematis, yakin ada keseimbangan." - George Gurdjieff
          </p>
        </div>
      </div>
    </div>

    <div class="container">
      <div class="d-flex justify-content-between pb-2">
        <div>
          <h2>Campaign</h2>
        </div>
        <div class="pt-2">
          <router-link
            class="btn btn-secondary btn-sm rounded"
            style="background-color: #00686b"
            :to="{ name: 'campaign' }"
            >Lihat Semua Campaign</router-link
          >
        </div>
      </div>
      <div v-if="loading" class="text-center" colspan="5 ">
        <div class="spinner-border" role="status">
          <span class="visually-hidden">Loading...</span>
        </div>
      </div>

      <div class="row row-cols-2 row-cols-lg-4 g-2 g-lg-3">
        <div class="col" v-for="item in campaign" :key="item.id">
          <router-link
            class="card text-decoration-none text-dark"
            :to="'/Campaign/' + item.slug"
          >
            <img
             :src="item.image ? 'http://localhost:8000/'+ item.image : 'https://dummyimage.com/16:9x1080'"
              class="card-img-top"
              height="200px"
              alt="..."
            />
            <div class="card-body">
              <h5 class="card-title">{{ item.title }}</h5>
              <!-- <a href="#" class="btn btn-success">Donate Now</a> -->
              <div class="progress">
                <div
                  class="
                    progress-bar progress-bar-striped progress-bar-animated
                  "
                  style="background-color: #00686b"
                  role="progressbar"
                  aria-valuenow="20"
                  aria-valuemin="0"
                  aria-valuemax="100"
                  :style="
                    'width:' +
                    formatProgress(item.total_donate, item.donate_required) +
                    '%'
                  "
                ></div>
              </div>

              <div class="d-flex justify-content-between py-1">
                <span>
                  <i class="bi bi-cash"></i>
                  {{ formatPrice(item.donate_required) }}
                </span>
                <span>
                  {{
                    formatProgress(item.total_donate, item.donate_required) +
                    "%"
                  }}
                </span>
              </div>
            </div>
          </router-link>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import { mapGetters } from "vuex";
import { mapMutations } from "vuex";

export default {
  data() {
    return {
      url: "http://localhost:8000",
      loading: false,
      campaign: [],
    };
  },

  methods: {
    getCampaign: function () {
      this.loading = true;
      const config = {
        methods: "get",
        url: this.url + "/api/Campaign/get-campaign/4",
      };
      axios(config)
        .then((response) => {
          this.campaign = response.data.Data.campaign;
          this.loading = false;
        })
        .catch((error) => {
          console.log(error);
        });
    },
    formatProgress(total_donate, donate_required) {
      let val = (total_donate / donate_required) * 100;
      return val.toFixed(0);
    },
    formatPrice(value) {
      let val = value / 1;
      return "Rp " + val.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ".");
    },
  },
  created() {
    this.getCampaign();
  },
};
</script>
